//+------------------------------------------------------------------+
//|                                               Net_builder_v3.mq4 |
//|                                            Copyright  2006, ASL |
//|                                        http://www.listforex.info |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, ASL"
#property link      "http://www.listforex.info"


extern double    lots=0.1;
extern double    tp=20;
extern int       action=1; //1 -  , -1 -  , 0 -   
extern int       max_orders=70;
extern int       step=14;

int global_flag=1;

#import "stdlib.ex4"
   string ErrorDescription(int);
#import


int start()
  {
//----

int cnt, flag, i, ticket;
double my_tp, my_ask, down_price, up_price, my_bid;


switch (action)
{ // switch
case 1:

//   ,    10 ,   ,  step

down_price=Ask-MathPow(0.1,Digits)*10;

for (i=down_price*MathPow(10,Digits); i>((down_price*MathPow(10,Digits))-50); i--)
{
if (MathMod(i,step)==0)
{
      my_ask=StrToDouble(DoubleToStr(i/MathPow(10,Digits), Digits));

// ,       
flag=1;
    for (cnt=0; cnt<OrdersTotal(); cnt++) //   
    {
        if(OrderSelect(cnt, SELECT_BY_POS)==true)
        {
        if (my_ask==OrderOpenPrice()&& OrderSymbol()==Symbol() ) 
            {
            flag=flag*0;
            }
        }
        else 
        {
        Comment("OrderSelect() [1]   - ",ErrorDescription(GetLastError()));
        }
    }
if (flag==1 && OrdersTotal()<max_orders)
{
my_tp=my_ask+tp/MathPow(10,Digits);
ticket=OrderSend(Symbol(),OP_BUYLIMIT,lots,my_ask,0,0,my_tp,"Open by Net_builder_v3",6346346,0,"green");  

if(ticket<0)
{
    Comment("OrderSend (BUY+1)   # ",ErrorDescription(GetLastError()) );
    return(0);
}
}
}
}
break;
case -1:
//   ,    10 ,   ,  step

up_price=Bid+MathPow(0.1,Digits)*10;

for (i=up_price*MathPow(10,Digits); i<((up_price*MathPow(10,Digits))+50); i++)
{
if (MathMod(i,step)==0)
{
my_bid=StrToDouble(DoubleToStr(i/MathPow(10,Digits), Digits));

// ,       
flag=1;
    for (cnt=0; cnt<OrdersTotal(); cnt++) //   
    {
        if(OrderSelect(cnt, SELECT_BY_POS)==true)
        {
        if (my_bid==OrderOpenPrice()&& OrderSymbol()==Symbol() ) 
            {
            flag=flag*0;
            }
        }
        else 
        {
        Comment("OrderSelect() [2]   - ",ErrorDescription(GetLastError()));
        }
    }
if (flag==1 && OrdersTotal()<max_orders)
{
   my_tp=my_bid-tp/MathPow(10,Digits);
ticket=OrderSend(Symbol(),OP_SELLLIMIT,lots,my_bid,0,0,my_tp,"Open by Net_builder_v3",6346346,0,"red");  

if(ticket<0)
{
    Comment("OrderSend (SELL-1)   # ",ErrorDescription(GetLastError()) );
    return(0);
}
}
}
}


break;

case 0:
switch (global_flag)
{
case 1:
//   ,    10 ,   ,  step

up_price=Bid+MathPow(0.1,Digits)*10;

for (i=up_price*MathPow(10,Digits); i<((up_price*MathPow(10,Digits))+50); i++)
{
if (MathMod(i,step)==0)
{
my_bid=StrToDouble(DoubleToStr(i/MathPow(10,Digits), Digits));

// ,       
flag=1;
    for (cnt=0; cnt<OrdersTotal(); cnt++) //   
    {
        if(OrderSelect(cnt, SELECT_BY_POS)==true)
        {
        if (my_bid==OrderOpenPrice()&& OrderSymbol()==Symbol() ) 
            {
            flag=flag*0;
            }
        }
        else 
        {
        Comment("OrderSelect() [3]   - ",ErrorDescription(GetLastError()));
        }
    }
if (flag==1 && OrdersTotal()<max_orders)
{
global_flag=-1;
   my_tp=my_bid-tp/MathPow(10,Digits);
ticket=OrderSend(Symbol(),OP_SELLLIMIT,lots,my_bid,0,0,my_tp,"Open by Net_builder_v3",6346346,0,"red");  

if(ticket<0)
{
    Comment("OrderSend (SELL-0)   # ",ErrorDescription(GetLastError()) );
    return(0);
}
}
}
}

break;
//+++++++++++++++++++++++++++++++++++++
//   ,    10 ,   ,  step

case -1:
down_price=Ask-MathPow(0.1,Digits)*10;

for (i=down_price*MathPow(10,Digits); i>((down_price*MathPow(10,Digits))-50); i--)
{
if (MathMod(i,step)==0)
{
      my_ask=StrToDouble(DoubleToStr(i/MathPow(10,Digits), Digits));

// ,       
flag=1;
    for (cnt=0; cnt<OrdersTotal(); cnt++) //   
    {
        if(OrderSelect(cnt, SELECT_BY_POS)==true)
        {
        if (my_ask==OrderOpenPrice()&& OrderSymbol()==Symbol() ) 
            {
            flag=flag*0;
            }
        }
        else 
        {
        Comment("OrderSelect() [4]   - ",ErrorDescription(GetLastError()));
        }
    }

if (flag==1 && OrdersTotal()<max_orders)
{
global_flag=1;
my_tp=my_ask+tp/MathPow(10,Digits);
ticket=OrderSend(Symbol(),OP_BUYLIMIT,lots,my_ask,0,0,my_tp,"Open by Net_builder_v3",6346346,0,CLR_NONE);  

if(ticket<0)
{
    Comment("OrderSend (BUY-0)   # ",ErrorDescription(GetLastError()) );
    return(0);
}
}
}
}
break;
}
break;

} // switch
return(0);
}
//---------------------------------------+